public final class Collision
{
	public static boolean HasCollided (ICollidable Object1, ICollidable Object2)
	{
		float   R1 = (Object1.GetDiameter() / 2);
		float   R2 = (Object2.GetDiameter() / 2);

		Vector  Normal = Vector.Normal(Object1.GetPosVector(), Object2.GetPosVector());
				
		if (Normal.GetLength() <= (R1 + R2))
			return true;
		
		return false;
	}
	
	public static Vector[] GetVelAfterCollision(Vector V1, Vector P1, float M1, 
	                                            Vector V2, Vector P2, float M2)
	{
		Vector[] NewObjectVelocities = new Vector[2];
		
		Vector UnitNormal  = Vector.Unit(Vector.Normal(P1, P2));
		Vector UnitTangent = Vector.Tangent(UnitNormal);
		
		double V1n = Vector.DotProduct(V1, UnitNormal);
		double V2n = Vector.DotProduct(V2, UnitNormal);
		float  V1t = Vector.DotProduct(V1, UnitTangent);
		float  V2t = Vector.DotProduct(V2, UnitTangent);
			
		float  V1N = (float)(((V1n * (M1 - M2)) + (2 * M2 * V2n)) / (M1 + M2));
		float  V2N = (float)(((V2n * (M2 - M1)) + (2 * M1 * V1n)) / (M2 + M1));

		NewObjectVelocities[0] = Vector.Add(Vector.Multiply(UnitNormal,  V1N),
		                                    Vector.Multiply(UnitTangent, V1t));

		NewObjectVelocities[1] = Vector.Add(Vector.Multiply(UnitNormal,  V2N),
		                                    Vector.Multiply(UnitTangent, V2t));

		return NewObjectVelocities;
	}
}