public final class Ship implements ICollidable
{
	private static int      TotalShips;

	private String          Name;
	private double          Heading;
	private Vector          Position;
	private Vector          Velocity;
	private Vector          Acceleration;
	private float           Mass;
	private double          Thrust;
	private Team            TeamData;
	private int             ShipID;
	private AI              AIModule;
	private int             TimeToFire;
	private int             Health;
	private int             Hits;
	private int             Misses;
	private int             Kills;
 
	public Ship (String Name,    Vector Position, Vector Velocity, Vector Acceleration,
                 double Heading, float Mass,      double Thrust,   Team   TeamData,
                 AI AIModule,    int Health)
	{
		this.Name         = Name;
		this.Position     = Position;
		this.Velocity     = Velocity;
		this.Acceleration = Acceleration;
		this.Heading      = Heading;
		this.Mass         = Mass;
		this.Thrust       = Thrust;
		this.TeamData     = TeamData;
		this.AIModule     = AIModule;
		this.Health       = Health;
		
		ShipID = TotalShips++;
	}

	public float GetDiameter ()
	{
		return Constants.SHIP_DIAMETER;
	}

	public String GetName ()
	{
		return Name;
	}

	public double GetHeading ()
	{
		return Heading;
	}

	public Vector GetPosVector ()
	{
		return Position;
	}

	public Vector GetVelVector ()
	{
		return Velocity;
	}
	
	public Vector GetAccVector ()
	{
		return Acceleration;
	}

	public int GetTimeToFire ()
	{
		return TimeToFire;
	}

	public float GetMass ()
	{
		return Mass;
	}

	public double GetThrust ()
	{
		return Thrust;
	}

	public Team GetTeam ()
	{
		return TeamData;
	}

	public int GetShipID ()
	{
		return ShipID;
	}

	public AI GetAI()
	{
		return AIModule;
	}

	public int GetHealth()
	{
		return Health;
	}

	public int GetHits()
	{
		return Hits;
	}

	public int GetMisses()
	{
		return Misses;
	}

	public int GetKills()
	{
		return Kills;
	}

	public void SetHits(int NewHits)
	{
		Hits = NewHits;
	}

	public void SetMisses(int NewMisses)
	{
		Misses = NewMisses;
	}
	
	public void SetKills(int NewKills)
	{
		Kills = NewKills;
	}

	public void SetHealth(int NewHealth)
	{
		Health = NewHealth;
	}
	
	public void SetHeading (double NewHeading)
	{
		Heading = NewHeading;
	}

	public void SetPosVector (Vector NewPosVector)
	{
		Position = NewPosVector;
	}

	public void SetVelVector (Vector NewVelVector)
	{
		Velocity = NewVelVector;
	}
	
	public void SetAccVector (Vector NewAccVector)
	{
		Acceleration = NewAccVector;
	}

	public void SetTimeToFire (int Frames)
	{
		TimeToFire = Frames;
	}
	
	public IMShip GetIMShip ()
	{
		return new IMShip(Name, Position.GetIMVector(), Heading,
		                  TeamData.GetIMTeam(), ShipID, Health);
	}
	
	public IMShipExt GetIMShipExt ()
	{
		return new IMShipExt(Name, Position.GetIMVector(), Velocity.GetIMVector(),
		                     Acceleration.GetIMVector(), Heading, Mass, Thrust,
		                     TeamData.GetIMTeam(), Health, ShipID);
	}
}
